#ifndef __CONFPARSER_H_
#define __CONFPARSER_H_

#include <string>
#include <vector>

struct ConfOption
{
	std::string name;
	std::string value;
};

class ConfParser
{
public:
	ConfParser();
	~ConfParser();
	bool LoadFile(const char *filename);
	bool GetStringValue(std::string name, std::string &value);
	bool GetIntValue(std::string name, int &value);
	bool GetBoolValue(std::string name, bool &value);
private:
	std::vector<ConfOption> options;
};

#endif

