#ifndef __COORDINATES_H_
#define __COORDINATES_H_
#include <iostream>

struct XYPlace
{
	int x;
	int y;
};

enum
{
	HEADING_UNDEFINED = -1,
	HEADING_N = 0,
	HEADING_NE,
	HEADING_E,
	HEADING_SE,
	HEADING_S,
	HEADING_SW,
	HEADING_W,
	HEADING_NW
};

//suunta on luku väliltä 0=N - 7=NW

class Heading
{
public:
	Heading(){
		headingval = -1;
	}
	bool operator == (Heading &h){
		if(h.headingval == headingval) return true;
		return false;
	}
	Heading operator = (int h){
		if(h != headingval) lastval = headingval;
		headingval = h;
		return *this;
	}
	bool operator == (int h){
		return headingval == h;
	}
	bool operator != (int h){
		return headingval != h;
	}
	Heading operator + (int &i){
		lastval = headingval;
		headingval += i;
		headingval = headingval % 8;
		if(headingval < 0) headingval += 8;
		return *this;
	}
	Heading operator - (int &i){
		lastval = headingval;
		headingval -= i;
		headingval = headingval % 8;
		if(headingval < 0) headingval += 8;
		return *this;
	}
	bool operator > (int &i){
		int dist_lower = headingval - i;
		int dist_higher = i - headingval;
		if(dist_higher < dist_lower) return true;
		else return false;
	}
	bool operator < (int &i){
		int dist_lower = headingval - i;
		int dist_higher = i - headingval;
		if(dist_higher > dist_lower) return true;
		else return false;
	}
	int GetVal(){
		return headingval;
	}
	int Get4WVal(){
		if(headingval % 2 == 0) return headingval/2;
		if(*this > lastval) return (headingval - 1)/2;
		if(*this < lastval) return (headingval + 1)/2;
		else return (headingval + 1)/2;
	}
private:
	int headingval;
	int lastval;
};

struct PlaceInfo
{
	XYPlace xy;
	Heading heading;
	unsigned int floor;
};


#endif

