#ifndef __IMAGE_H_
#define __IMAGE_H_

#include "coordinates.h"
#include <SDL/SDL.h>
#include <vector>

class Way4Image
{
public:
	Way4Image();
	~Way4Image();
	SDL_Surface* GetImage(Heading heading);
	void SetImages(SDL_Surface **images_);
	void FreeImages();
private:
	SDL_Surface *images[4];
	Heading lastvalidheading;
};

struct AnimationImageBase
{
	int duration_ms;
};

struct AnimationImage : public AnimationImageBase
{
	AnimationImage();
	void FreeImage();
	SDL_Surface *image;
};

struct AnimationWay4Image : public AnimationImageBase
{
	Way4Image image;
};

class AnimationBase
{
public:
	AnimationBase();
	void ToStart();
	void RollFrames(int timenow_ms);
protected:
	unsigned int currentimage, imagecount;
	std::vector<AnimationImageBase> imagebases;
private:
	void CycleCurrentImage();
	int lastframetime_ms;
};

class Way4Animation : public AnimationBase
{
public:
	SDL_Surface* GetCurrentImage(Heading heading);
	void AddImage(AnimationWay4Image image);
	void FreeImages();
private:
	std::vector<AnimationWay4Image> images;
};

class Animation : public AnimationBase
{
public:
	SDL_Surface* GetCurrentImage();
	void AddImage(AnimationImage image);
	void FreeImages();
private:
	std::vector<AnimationImage> images;
};

#endif

