#ifndef __MAPIMAGELIB_H_
#define __MAPIMAGELIB_H_

#include "SDL/SDL.h"
#include "image.h"
#include <vector>
#include <string>

class MapImage
{
public:
	~MapImage();
	MapImage();
	MapImage(std::string shortid, Animation under, Animation over,
			int backswapy);
	bool SetAll(std::string shortid, Animation under, Animation over,
			int backswapy);
	void FreeAll();

	std::string GetShortID();
	Animation& GetUnderAnim();
	Animation& GetOverAnim();
	int GetBackSwapY();
	
	void RollAnims(int timenow_ms);

	void GetSizeTiles(int &w, int &h);

private:
	bool SetAnims(Animation under, Animation over);
	void FreeAnims();
	std::string shortid;
	int w_tiles, h_tiles;
	int w_px, h_px;
	Animation under_anim, over_anim;
	bool anims_loaded;
	int backswapy;
};

class MapImageLib
{
public:
	~MapImageLib();
	int Load(std::string path);
	void Clear();
	std::vector<std::string> ListIDs();
	MapImage* GetImage(std::string shortid);
	void RollAnims(int timenow_ms);
private:
	std::vector<MapImage> mapimages;
};

#endif

