#ifndef __OBJECT_H_
#define __OBJECT_H_

#include "objectimagelib.h"
#include "coordinates.h"
#include "script.h"
#include "SDL/SDL.h"
#include "task.h"
#include <vector>
#include <string>

class Script;

class Object
{
public:
	Object();

	void SetPlaceInfo(PlaceInfo i);
	PlaceInfo* GetPlaceInfo();

	void SetScript(Script *s);
	Script *GetScript();
	
	void SetImageChunk(ObjectImageChunk imagechunk_);
	ObjectImageChunk* GetImageChunk();

	void SetCurrentImageID(int current_image_id_);
	int GetCurrentImageID();
	
	SDL_Surface* GetCurrentImage();
	void RollAnim(int timenow_ms);

	Task * GetTask();
	void SetTask(Task task_);
	
private:
	//0 = pääkuva, 1 = liikkumisanimaatio, 2-> = muut animaatiot
	int current_image_id;
	PlaceInfo placeinfo; //x/y, heading, floor
	ObjectImageChunk imagechunk; //kuvat, animaatiot
	Script *script;
	Task task;
};

#endif

