#ifndef __TILELIB_H_
#define __TILELIB_H_

#include <SDL/SDL.h>
#include <vector>
#include <string>

struct Tile
{
	std::string shortid;
	SDL_Surface* image;
};

class TileLib
{
public:
	TileLib();
	~TileLib();
	int Load(std::string path);
	void Clear();
	std::vector<std::string> ListIDs();
	SDL_Surface* GetImage(std::string shortid);
private:
	std::vector<Tile> tiles;
};

#endif

