#include "confparser.h"
#include "commonfunctions.h"
#include <iostream>
#include <fstream>
#include <stdlib.h>

ConfParser::ConfParser()
{
}

ConfParser::~ConfParser()
{
}

bool ConfParser::LoadFile(const char *filename)
{
	options.clear();
	std::fstream file(filename, std::fstream::in);
	if(!file.good()){
		std::cout<<"ConfParser::LoadFile(): failed to open file "
				<<filename<<" for reading"<<std::endl;
		return false;
	}
	char line[1000];
	for(;!file.eof();){
		file.getline(line, 999);
		Strfnd f(line);
		ConfOption o;
		o.name = trim(f.next("="));
		o.value = trim(f.next(""));
		options.push_back(o);
	}
	file.close();
	return true;
}

bool ConfParser::GetStringValue(std::string name, std::string &value)
{
	for(unsigned int i=0; i<options.size(); i++){
		if(options[i].name == name){
			value = options[i].value;
			return true;
		}
	}
	std::cout<<"ConfParser::GetStringValue(): ERROR: option \""
			<<name<<"\" not found"<<std::endl;
	return false;
}

bool ConfParser::GetIntValue(std::string name, int &value)
{
	for(unsigned int i=0; i<options.size(); i++){
		if(options[i].name == name){
			value = atoi(options[i].value.c_str());
			return true;
		}
	}
	std::cout<<"ConfParser::GetIntValue(): ERROR: option \""
			<<name<<"\" not found"<<std::endl;
	return false;
}

bool ConfParser::GetBoolValue(std::string name, bool &value)
{
	for(unsigned int i=0; i<options.size(); i++){
		if(options[i].name == name){
			if(options[i].value == "true") value = true;
			else if(options[i].value == "false") value = false;
			else if(options[i].value == "1") value = true;
			else if(options[i].value == "0") value = false;
			else{
				std::cout<<"ConfParser::GetBoolValue(): ERROR: invalid boolean value \""
						<<options[i].value<<"\""<<std::endl;
				return false;
			}
			return true;
		}
	}
	std::cout<<"ConfParser::GetBoolValue(): ERROR: option \""
			<<name<<"\" not found"<<std::endl;
	return false;
}

