#include "object.h"
#include "string.h"

Object::Object()
{
	current_image_id = 0;
	task.Clear();
}

void Object::SetPlaceInfo(PlaceInfo i)
{
	placeinfo = i;
	//std::cout<<"Object::SetPlaceInfo(): "<<placeinfo.xy.x<<","<<placeinfo.xy.y<<std::endl;
}

PlaceInfo* Object::GetPlaceInfo()
{
	//std::cout<<"Object::GetPlaceInfo(): "<<placeinfo.xy.x<<","<<placeinfo.xy.y<<std::endl;
	return &placeinfo;
}

void Object::SetScript(Script *s)
{
	script = s;
}

Script *Object::GetScript()
{
	return script;
}

void Object::SetImageChunk(ObjectImageChunk imagechunk_)
{
	imagechunk = imagechunk_;
}

ObjectImageChunk* Object::GetImageChunk()
{
	return &imagechunk;
}

void Object::SetCurrentImageID(int current_image_id_)
{
	current_image_id = current_image_id_;
}

int Object::GetCurrentImageID()
{
	return current_image_id;
}

SDL_Surface* Object::GetCurrentImage()
{
	//pääkuva
	if(current_image_id == 0){
		return imagechunk.main_image.GetImage(placeinfo.heading);
	}
	//liikkumisanimaatio
	else if(current_image_id == 1){
		SDL_Surface *s = imagechunk.move_animation.GetCurrentImage(placeinfo.heading);
		if(s==NULL) return imagechunk.main_image.GetImage(placeinfo.heading);
		else return s;
	}
	//muu animaatio
	else if(current_image_id >= 2){
		imagechunk.other_animations[current_image_id - 2].GetCurrentImage();
	}
	return NULL;
}

void Object::RollAnim(int timenow_ms)
{
	//pääkuva
	if(current_image_id == 0){
	}
	//liikkumisanimaatio
	else if(current_image_id == 1){
		imagechunk.move_animation.RollFrames(timenow_ms);
	}
	//muu animaatio
	else if(current_image_id >= 2){
		imagechunk.other_animations[current_image_id - 2].RollFrames(timenow_ms);
	}
}

Task * Object::GetTask()
{
	return &task;
}

void Object::SetTask(Task task_)
{
	task = task_;
}

