#include "variables.h"

bool VariableNode::GetBool()
{
	if(data[0] >= '1')
		return 1;
	else
		return 0;
}

int VariableNode::GetInt()
{
#ifdef _MSC_VER
	return atoi(data.c_str());
#else
	return std::atoi(data.c_str());
#endif
}

std::string VariableNode::GetString()
{
	return data;
}

void VariableNode::SetInt(int i)
{
	std::stringstream s;
	s << i;
	data = s.str();
}
	
void VariableNode::SetBool(bool b)
{
	if(b == true)
		data = "1";
	else
		data = "0";
}

void VariableNode::SetString(std::string s)
{
	data = s;
}

Variables::Variables()
{
}

Variables::Variables(std::string _file) : file(_file)
{
	std::ifstream ifile(file.c_str(), std::ifstream::binary);
	unsigned int i;
	const unsigned int buffer_len = 512;
	char buffer[512];
	VariableNode node;
	
	if(!ifile.is_open()) {
		std::ofstream ofile;
		ofile.open(file.c_str());
		ofile.close();
		ifile.open(file.c_str(), std::ifstream::binary);
		if(!ifile.is_open())
			std::cerr << "Couldn't open/create variable file!\n";
		return;
	}
	// Filu auki, otetaan juttuja 
	// (int nimen_pituus, nimidataa, int sisallon_pituus, sisaltodataa)
	// ja sitten laitetaan ne muistiin
	while(!ifile.eof()) {
		if(ifile.read((char*)&i, sizeof(int)) == 0) {
			std::cerr << "File seems empty" << "\n";
			break;
		}
		if(i > buffer_len) {
			std::cerr << "Name's length > " << buffer_len << "!\n";
			continue;
		}
		ifile.read(buffer, i > buffer_len ? buffer_len: i);
		buffer[ifile.gcount()] = '\0';
		node.name = buffer;
		ifile.read((char*)&i, sizeof(int));
		if(i > buffer_len) {
			std::cerr << "Str's length > " << buffer_len << "!\n";
			continue;
		}
		ifile.read(buffer, i > buffer_len ? buffer_len: i);
		buffer[ifile.gcount()] = '\0';
		node.data = (char*)buffer;
		nodes.push_back(node);
	}
	ifile.close();
}

int Variables::Write()
{
	if(file=="") return 0;
	std::ofstream ofile;
	ofile.open(file.c_str(), std::ofstream::binary);
	int len;
	if(!ofile.is_open()) {
		std::cerr << "Couldn't write vars!\n";
		return 1;
	}
	std::list<VariableNode>::iterator it;
	for(it = nodes.begin(); it != nodes.end(); it++) {
		if(it->name != "") {
			len = it->name.size();
			ofile.write((char*)&len, sizeof(int));
			ofile.write(it->name.c_str(), len);
			len = it->GetString().size();
			ofile.write((char*)&len, sizeof(int));
			ofile.write(it->GetString().c_str(), len);
		}
	}
	ofile.close();
	return 0;
}


VariableNode & Variables::FindVar(std::string name)
{
	static VariableNode empty;
	std::list<VariableNode>::iterator it;
	for(it = nodes.begin(); it != nodes.end(); it++) {
		if(it->name == name) {
			return *it;
		}
	}
	empty.name = "";
	return empty;
}
int Variables::AddVar(VariableNode & node) {
	std::list<VariableNode>::iterator it;
	for(it = nodes.begin(); it != nodes.end(); it++) {
		if(it->name == node.name)
			return 1;
	}
	nodes.push_back(node);
	return 0;
}

